/*
Scrivere un programma per la gestione delle prenotazioni dei viaggi. Ogni  prenotazione  caratterizzata dalle seguenti informazioni: cognome e nome, partenza, arrivo, codice prenotazione (es EDG24TW),  data viaggio.
Le prenotazioni sono organizzate in memoria come un vettore di 80 elementi
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova prenotazione;
2)Visualizzazione delle prenotazioni relative a una certa data (chiedere la data);
3) Cambio di prenotazione ( chiedere il codice prenotazione e la nuova data);
4) Salvataggio su file dei passeggeri;
5) Lettura da file e visualizzazione sullo schermo delle prenotazioni relative a una certa data (chiedere la data);

*/


#include <stdio.h>
#include <string.h>

struct prenotazione {
       char nome[20];
       char cognome[20];
       char partenza[20];
       char arrivo[20];
       char codice[15];
       char data[10];
       };
       
void inserisci(struct prenotazione *V,int *pn)
{    
     struct prenotazione p; 
     if(*pn<80){
                printf("\nNome: ");
                scanf("%s",p.nome);
                printf("Cognome: ");
                scanf("%s",p.cognome);
                printf("Luogo di partenza: ");
                scanf("%s",p.partenza);
                printf("Destinazione: ");
                scanf("%s",p.arrivo);
                printf("Codice prenotazione: ");
                scanf("%s",p.codice);
                printf("Data(gg/mm/aaaa): ");
                scanf("%s",p.data);
                
                V[*pn]=p;
                (*pn)++;
                }
     else printf("vettore pieno!");
}

void visualizza(struct prenotazione *V,int n)
{
     int i;
     char data[10];
     
     printf("data(gg/mm/aaaa): ");
     scanf("%s",data);
     
     for(i=0;i<n;i++)
          if(strcmp(V[i].data,data)==0)
           {
               printf("\nCognome: %s",V[i].cognome);
               printf("\nNome: %s",V[i].nome);
               printf("\nLuogo di partenza: %s",V[i].partenza);
               printf("\nLuogo di arrivo; %s",V[i].arrivo);
               printf("\nCodice prenotazione: %s\n",V[i].codice);
           }
                                                               
}

void cambia(struct prenotazione *V,int n)
{
     char codice[15];
     int i;
     
     printf("\ncodice prenotazione: ");
     scanf("%s",codice);
     
     for(i=0;i<n;i++)
        if(strcmp(V[i].codice,codice)==0)
             break;
     
     if(i<n){
              printf("\ninserisci nuova data(gg.mm.aaaa): ");
              scanf("%s",V[i].data);
             }
     else printf("\nPRENOTAZIONE NON TROVATA!\n");
}

void salva(struct prenotazione *V,int n)
{
     FILE *pf;
     int i;
     
     pf=fopen("prenotazioni.pre","wb");
     if(pf){
             for(i=0;i<n;i++)
                 fwrite(&V[i],sizeof(struct prenotazione),1,pf);
             fclose(pf);
            }
     else printf("errore!");
}

void leggi()
{
     FILE *pf;
     struct prenotazione p;
     char data[15];
     
     
     
     
     pf=fopen("prenotazioni.pre","rb");
     if(pf){
            printf("\nInserisci la data: ");
            scanf("%s",data);
            while(fread(&p,sizeof(struct prenotazione),1,pf)>0)
              if(strcmp(p.data,data)==0)
                  {                           
                   printf("\nCognome: %s",p.cognome);
                   printf("\nNome: %s",p.nome);
                   printf("\nLuogo partenza: %s",p.partenza);
                   printf("\nLuogo arrivo: %s",p.arrivo);
                   printf("\nCodice prenotazione: %s\n",p.codice);
                  }
            fclose(pf);
           }
      else printf("errore!\n");
}                                               
       
main(){
       struct prenotazione P[80];
       int n,scelta;
       
       n=0;
       
       do{
           printf("\nScegli l'operazione da eseguire:\n");
           printf("1)inserisci prenotazione\n2)visualizza prenotazioni");
           printf("\n3)cambia prenotazione\n4)salva prenotazioni");
           printf("\n5)leggi da file e visualizza");
           printf("\n0) fine\n");
           scanf("%d",&scelta);
           
           switch(scelta){
                          case 1: inserisci(P,&n);
                                  break;
                          case 2: visualizza(P,n);
                                  break;
                          case 3: cambia(P,n);
                                  break;
                          case 4: salva(P,n);
                                  break;
                          case 5: leggi();
                                  break;
                          default:;
                          }
           }while(scelta!=0);
           
           
       }
                      
       
       
